//DokumenteVereinen_404d.js
// 09.01.14 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Mehrere Dokumente zu einem einzigen zusammenfgen

// vorbeugenderweise das Anzeigen von Dialogen aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// prfen, ob ein Dokument offen ist
if (app.documents.length != 0) {
	alert ("Es darf *kein* Dokument offen sein.", "Achtung");
	exit();
}

// das Auswhlen eines Ordners
var selFolder = "/d/"
var folderObj = File (Folder.selectDialog("Den Ordner auswhlen, welcher die\nzusammenzufgenden Dokumente enthlt.", selFolder));
var testObj = "" + folderObj;
if (testObj.match("null")) {
	exit();
}

// den Inhalt des Ordners auflisten
var docsList = folderObj.getFiles("*.indd");

var probCtr = 0;

// das Anzeigen von Dialogen deaktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.neverInteract;
try {
	// versuchen, das erste Dokument zu ffnen
	app.open(File(docsList[0]));
	// das Anzeigen von Dialogen aktivieren
	app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;
}
catch (e) {
	// das Anzeigen von Dialogen aktivieren
	app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;
	alert ("Die erste Datei kann nicht geffnet werden.", "Problem");
	exit();
}

// das erste Dokument
var curDoc = app.documents[0];
// der Name des Dokuments
var docName = curDoc.name.slice(0, -5);
// einen "x" anhngen
var newName = docName + "x";
// den Dateipfad zusammensetzen
var fullPath = folderObj + "/" + newName + ".indd";

// sicherstellen, dass sich nicht noch die mglicherweise gleichnamige Datei im Ordner befindet
var fi = File(fullPath).exists; 
if (fi == true) {
	alert ("Achtung: Die Datei\n\n" + newName + ".indd\n\naus dem Ordner entfernen\nund das Script nochmals starten.", "Stop");
	exit();
}

// speichern, ob Doppel- oder Einzelseiten
var doublePage = curDoc.documentPreferences.facingPages;
if (doublePage) {
	// "Neue Seitenanordnung zulassen" aktivieren
	curDoc.documentPreferences.allowPageShuffle = true;
}
else {
	// "Neue Seitenanordnung zulassen" deaktivieren
	curDoc.documentPreferences.allowPageShuffle = false;
}

// die Datei unter dem neuen Namen speichern
curDoc.save(new File(fullPath));

// das Anzeigen von Dialogen deaktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.neverInteract;

// eine Schleife durch die weiteren Dokumente
var diffVal;
var firstPage;
var lastPage;
var newDoc;
var nSpreads;
var pS;
var startPg;
for (var i=1; i<docsList.length; i++) {
	lastPage = (curDoc.pages.item(-1).name)*1;
	app.open(File(docsList[i]));
	newDoc = app.documents[0];
	firstPage = (newDoc.pages[0].name)*1;
	nSpreads = newDoc.spreads.length;
	diffVal = (firstPage - lastPage);
	
	if (diffVal != 1) {
		// "Neue Seitenanordnung zulassen" deaktivieren
		app.documents[1].documentPreferences.allowPageShuffle = false;
		// die neue Startseite festlegen
		startPg = app.documents[0].pages[0].name;
		try {
			// den ersten Druckbogen kopieren
			newDoc.spreads[0].duplicate(LocationOptions.after, app.documents[1].spreads[-1]);
			// einen neuen Abschnitt definieren
			pS = app.documents[1].pages.item(startPg);
			curDoc.sections.add({pageStart:pS,continueNumbering:false, pageNumberStart:firstPage});
			// die Funktion aufrufen, welche das Abschnittsprfix entfernt
			delSect();
		}
		catch (e) {
			probCtr++;
		}
		
		if (nSpreads > 1) {
			for (var s=1; s<nSpreads; s++) {
				try {
					newDoc.spreads[s].duplicate(LocationOptions.after, app.documents[1].spreads[-1]);
				}
				catch (e) {
					probCtr++;
				}
				lastPage = (curDoc.pages.item(-1).name)*1;
				if (doublePage && (lastPage % 2 == 0)) {
					// "Neue Seitenanordnung zulassen" aktivieren
					curDoc.documentPreferences.allowPageShuffle = true;
				}
				else {
					// "Neue Seitenanordnung zulassen" deaktivieren
					curDoc.documentPreferences.allowPageShuffle = false;
				}
			}
		}
	}
	else {
		if (lastPage % 2 == 0) {
			// "Neue Seitenanordnung zulassen" aktivieren
			curDoc.documentPreferences.allowPageShuffle = true;
		}
		for (var s=0; s<nSpreads; s++) {
			try {
				newDoc.spreads[s].duplicate(LocationOptions.after, app.documents[1].spreads[-1]);
			}
			catch (e) {
				probCtr++;
			}
			lastPage = (curDoc.pages.item(-1).name)*1;
			if (doublePage && (lastPage % 2 == 0)) {
					// "Neue Seitenanordnung zulassen" aktivieren
				curDoc.documentPreferences.allowPageShuffle = true;
			}
			else {
				// "Neue Seitenanordnung zulassen" deaktivieren
				curDoc.documentPreferences.allowPageShuffle = false;
			}
		}
	}
	newDoc.close(SaveOptions.no);
}

// das Dokument abschliessend speichern
curDoc.save();

// das Anzeigen von Dialogen wieder aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// das war's
if (probCtr == 0) {
	var dlog = new Window("palette");
	dlog.size = [320,100];
	dlog.add("statictext", [80, 100, 320, 116], "Fertig, keine Probleme.");
	dlog.show();
	// eine kleine Pause
	$.sleep(1500);
	// das Fenster schliessen
	dlog.close();
}
else if (probCtr == 1) {
	alert ("Ein Druckbogen konnte nicht eingefgt werden.", "Achtung");
}
else if (probCtr > 1) {
	alert ("" + probCtr + " Druckbogen konnten nicht eingefgt werden.", "Achtung");
}

// die Funktion, welche eventuelle Abschnitts-Prfizes entfernt (damit die Seiten richtig adressiert werden knnen)
function delSect() {
	allSections = app.documents[0].sections;
	for (var i=0; i<allSections.length; i++) {
		try {
			allSections[i].sectionPrefix = "";
		}
		catch (e) {
		}
	}
}
